diff --git a/src/cdogs/keyboard.c b/src/cdogs/keyboard.c
index 78c5cceac..145677df1 100644
--- a/src/cdogs/keyboard.c
+++ b/src/cdogs/keyboard.c
@@ -37,6 +37,7 @@ void KeyInit(keyboard_t *keyboard)
 {
 	memset(keyboard->current_keys, 0, sizeof(keyboard->current_keys));
 	memset(keyboard->previous_keys, 0, sizeof(keyboard->previous_keys));
+	keyboard->modState = KMOD_NONE;
 }
 
 void KeyPoll(keyboard_t *keyboard)
@@ -55,6 +56,7 @@ void KeyPoll(keyboard_t *keyboard)
 			break;
 		}
 	}
+	keyboard->modState = SDL_GetModState();
 }
 
 int KeyIsDown(keyboard_t *keyboard, int key)
diff --git a/src/cdogs/keyboard.h b/src/cdogs/keyboard.h
index 89b96b48a..f2189fa0b 100644
--- a/src/cdogs/keyboard.h
+++ b/src/cdogs/keyboard.h
@@ -155,6 +155,7 @@ typedef struct
 	SDL_Event keyevent;
 	int previous_keys[512];
 	int current_keys[512];
+	SDLMod modState;
 } keyboard_t;
 extern keyboard_t gKeyboard;
 
diff --git a/src/cdogsed.c b/src/cdogsed.c
index 12213a4ce..45bdf358b 100644
--- a/src/cdogsed.c
+++ b/src/cdogsed.c
@@ -1267,8 +1267,10 @@ static void Save(int asCode)
 		BlitFlip(&gGraphicsDevice, &gConfig.Graphics);
 
 		c = GetKey(&gKeyboard);
-		switch (c) {
-		case ENTER:
+		switch (c)
+		{
+		case SDLK_RETURN:
+		case SDLK_KP_ENTER:
 			if (!filename[0])
 				break;
 			if (asCode) {
@@ -1279,10 +1281,10 @@ static void Save(int asCode)
 			fileChanged = 0;
 			return;
 
-		case ESCAPE:
+		case SDLK_ESCAPE:
 			return;
 
-		case BACKSPACE:
+		case SDLK_BACKSPACE:
 			if (filename[0])
 				filename[strlen(filename) - 1] = 0;
 			break;
@@ -1317,231 +1319,269 @@ static int ConfirmQuit(void)
 	return (c == 'Y' || c == 'y');
 }
 
-static void EditCampaign(void)
+static void Delete(int xc, int yc, int *mission)
 {
-	int done = 0;
-	int mission = 0;
-	int xc = 0, yc = 0;
-	int xcOld, ycOld;
-	struct Mission scrap;
-	struct EditorInfo edInfo;
-	int tag;
+	switch (yc)
+	{
+	case YC_CHARACTERS:
+		DeleteCharacter(xc);
+		break;
 
-	GetEditorInfo(&edInfo);
+	case YC_SPECIALS:
+		DeleteSpecial(xc);
+		break;
 
-	memset(&scrap, 0, sizeof(scrap));
-	MouseSetRects(&gMouse, localClicks, NULL);
+	case YC_ITEMS:
+		DeleteItem(xc);
+		break;
 
-	gCampaign.Setting = campaign;
-	gCampaign.seed = 0;
-	Setup(mission, 1);
+	default:
+		if (yc >= YC_OBJECTIVES)
+		{
+			DeleteObjective(yc - YC_OBJECTIVES);
+		}
+		else
+		{
+			DeleteMission(mission);
+		}
+		AdjustYC(&yc);
+		break;
+	}
+	fileChanged = 1;
+	Setup(*mission, 0);
+}
 
-	SDL_EnableKeyRepeat(0, 0);
-	while (!done)
+static void HandleInput(
+	int c, int *xc, int *yc, int *mission, struct Mission *scrap, int *done)
+{
+	if (gKeyboard.modState & (KMOD_ALT | KMOD_CTRL))
 	{
-		int c;
-		KeyPoll(&gKeyboard);
-		c = KeyGetPressed(&gKeyboard);
-		MousePoll(&gMouse);
-		if (gMouse.currentButtons)
+		switch (c)
 		{
-			if (MouseTryGetRectTag(&gMouse, &tag))
+		case 'x':
+			*scrap = campaign.missions[*mission];
+			Delete(*xc, *yc, mission);
+			break;
+
+		case 'c':
+			*scrap = campaign.missions[*mission];
+			break;
+
+		case 'v':
+			InsertMission(*mission, scrap);
+			fileChanged = 1;
+			Setup(*mission, 0);
+			break;
+
+		case 'q':
+			if (!fileChanged || ConfirmQuit())
 			{
-				xcOld = xc;
-				ycOld = yc;
-				if ((tag & LEAVE_YC) == 0)
-				{
-					yc = (tag & 0xFF);
-					AdjustYC(&yc);
-				}
-				if ((tag & LEAVE_XC) == 0)
-				{
-					xc = ((tag >> 8) & 0xFF);
-					AdjustXC(yc, &xc);
-				}
-				if ((tag & SELECT_ONLY) != 0)
-				{
-					c = DUMMY;
-				}
-				else if (!(tag & SELECT_ONLY_FIRST) ||
-					(xc == xcOld && yc == ycOld))
-				{
-					c = gMouse.currentButtons == SDL_BUTTON_LEFT ?
-						PAGEUP : PAGEDOWN;
-				}
-				else
-				{
-					c = DUMMY;
-				}
+				*done = 1;
 			}
-		}
+			break;
 
-		switch (c) {
-		case HOME:
-			if (mission > 0)
-				mission--;
-			Setup(mission, 0);
+		case 'n':
+			InsertMission(campaign.missionCount, NULL);
+			*mission = campaign.missionCount - 1;
+			fileChanged = 1;
+			Setup(*mission, 0);
 			break;
 
-		case END:
-			if (mission < campaign.missionCount)
-				mission++;
-			Setup(mission, 0);
+		case 's':
+			Save(0);
 			break;
 
-		case INSERT:
-			switch (yc) {
+		case 'h':
+			Save(1);
+			break;
+
+		case 'm':
+			Setup(*mission, 0);
+			SetupMap();
+			DisplayAutoMap(1);
+			GetKey(&gKeyboard);
+			KillAllObjects();
+			FreeTriggersAndWatches();
+			break;
+
+		case 'e':
+			EditCharacters(&campaign);
+			Setup(*mission, 0);
+			MouseSetRects(&gMouse, localClicks, NULL);
+			break;
+		}
+	}
+	else
+	{
+		switch (c)
+		{
+		case SDLK_HOME:
+			if (*mission > 0)
+			{
+				(*mission)--;
+			}
+			Setup(*mission, 0);
+			break;
+
+		case SDLK_END:
+			if (*mission < campaign.missionCount)
+				(*mission)++;
+			Setup(*mission, 0);
+			break;
+
+		case SDLK_INSERT:
+			switch (*yc)
+			{
 			case YC_CHARACTERS:
 				currentMission->baddieCount =
 					CLAMP(currentMission->baddieCount + 1, 0, BADDIE_MAX);
-				xc = currentMission->baddieCount - 1;
+				*xc = currentMission->baddieCount - 1;
 				break;
 
 			case YC_SPECIALS:
 				currentMission->specialCount =
 					CLAMP(currentMission->specialCount + 1, 0, SPECIAL_MAX);
-				xc = currentMission->specialCount - 1;
+				*xc = currentMission->specialCount - 1;
 				break;
 
 			case YC_ITEMS:
 				currentMission->itemCount =
 					CLAMP(currentMission->itemCount + 1, 0, ITEMS_MAX);
-				xc = currentMission->itemCount - 1;
+				*xc = currentMission->itemCount - 1;
 				break;
 
 			default:
-				if (yc >= YC_OBJECTIVES)
+				if (*yc >= YC_OBJECTIVES)
+				{
 					AddObjective();
+				}
 				else
-					InsertMission(mission, NULL);
-				break;
-			}
-			fileChanged = 1;
-			Setup(mission, 0);
-			break;
-
-		case ALT_X:
-			scrap = campaign.missions[mission];
-
-		case DELETE:
-			switch (yc) {
-			case YC_CHARACTERS:
-				DeleteCharacter(xc);
-				break;
-
-			case YC_SPECIALS:
-				DeleteSpecial(xc);
-				break;
-
-			case YC_ITEMS:
-				DeleteItem(xc);
-				break;
-
-			default:
-				if (yc >= YC_OBJECTIVES)
-					DeleteObjective(yc -
-							YC_OBJECTIVES);
-				else
-					DeleteMission(&mission);
-				AdjustYC(&yc);
+				{
+					InsertMission(*mission, NULL);
+				}
 				break;
 			}
 			fileChanged = 1;
-			Setup(mission, 0);
-			break;
-
-		case ALT_C:
-			scrap = campaign.missions[mission];
+			Setup(*mission, 0);
 			break;
 
-		case ALT_V:
-			InsertMission(mission, &scrap);
-			fileChanged = 1;
-			Setup(mission, 0);
+		case SDLK_DELETE:
+			Delete(*xc, *yc, mission);
 			break;
 
-		case ALT_N:
-			InsertMission(campaign.missionCount, NULL);
-			mission = campaign.missionCount - 1;
-			fileChanged = 1;
-			Setup(mission, 0);
+		case SDLK_UP:
+			(*yc)--;
+			AdjustYC(yc);
+			AdjustXC(*yc, xc);
 			break;
 
-		case ARROW_UP:
-			yc--;
-			AdjustYC(&yc);
-			AdjustXC(yc, &xc);
+		case SDLK_DOWN:
+			(*yc)++;
+			AdjustYC(yc);
+			AdjustXC(*yc, xc);
 			break;
 
-		case ARROW_DOWN:
-			yc++;
-			AdjustYC(&yc);
-			AdjustXC(yc, &xc);
+		case SDLK_LEFT:
+			(*xc)--;
+			AdjustXC(*yc, xc);
 			break;
 
-		case ARROW_LEFT:
-			xc--;
-			AdjustXC(yc, &xc);
+		case SDLK_RIGHT:
+			(*xc)++;
+			AdjustXC(*yc, xc);
 			break;
 
-		case ARROW_RIGHT:
-			xc++;
-			AdjustXC(yc, &xc);
-			break;
-
-		case PAGEUP:
-			if (Change(yc, xc, 1, &mission))
+		case SDLK_PAGEUP:
+			if (Change(*yc, *xc, 1, mission))
+			{
 				fileChanged = 1;
-			Setup(mission, 0);
+			}
+			Setup(*mission, 0);
 			break;
 
-		case PAGEDOWN:
-			if (Change(yc, xc, -1, &mission))
+		case SDLK_PAGEDOWN:
+			if (Change(*yc, *xc, -1, mission))
+			{
 				fileChanged = 1;
-			Setup(mission, 0);
+			}
+			Setup(*mission, 0);
 			break;
 
-		case ESCAPE:
-		case ALT_Q:
+		case SDLK_ESCAPE:
 			if (!fileChanged || ConfirmQuit())
-				done = 1;
+			{
+				*done = 1;
+			}
 			break;
 
-		case BACKSPACE:
-			DelChar(xc, yc);
+		case SDLK_BACKSPACE:
+			DelChar(*xc, *yc);
 			fileChanged = 1;
 			break;
 
-		case ALT_S:
-			Save(0);
+		default:
+			if (c >= ' ' && c <= 'z')
+			{
+				fileChanged = 1;
+				AddChar(*xc, *yc, (char)c);
+			}
 			break;
+		}
+	}
+}
 
-		case ALT_H:
-			Save(1);
-			break;
+static void EditCampaign(void)
+{
+	int done = 0;
+	int mission = 0;
+	int xc = 0, yc = 0;
+	int xcOld, ycOld;
+	struct Mission scrap;
+	struct EditorInfo edInfo;
+	int tag;
 
-		case ALT_M:
-			Setup(mission, 0);
-			SetupMap();
-			DisplayAutoMap(1);
-			GetKey(&gKeyboard);
-			KillAllObjects();
-			FreeTriggersAndWatches();
-			break;
+	GetEditorInfo(&edInfo);
 
-		case ALT_E:
-			EditCharacters(&campaign);
-			Setup(mission, 0);
-			MouseSetRects(&gMouse, localClicks, NULL);
-			break;
+	memset(&scrap, 0, sizeof(scrap));
+	MouseSetRects(&gMouse, localClicks, NULL);
 
-		default:
-			if (c >= ' ' && c <= 'z') {
-				fileChanged = 1;
-				AddChar(xc, yc, (char)c);
+	gCampaign.Setting = campaign;
+	gCampaign.seed = 0;
+	Setup(mission, 1);
+
+	SDL_EnableKeyRepeat(0, 0);
+	while (!done)
+	{
+		int c;
+		KeyPoll(&gKeyboard);
+		c = KeyGetPressed(&gKeyboard);
+		MousePoll(&gMouse);
+		if (gMouse.currentButtons)
+		{
+			if (MouseTryGetRectTag(&gMouse, &tag))
+			{
+				xcOld = xc;
+				ycOld = yc;
+				if ((tag & LEAVE_YC) == 0)
+				{
+					yc = (tag & 0xFF);
+					AdjustYC(&yc);
+				}
+				if ((tag & LEAVE_XC) == 0)
+				{
+					xc = ((tag >> 8) & 0xFF);
+					AdjustXC(yc, &xc);
+				}
+				else if (!(tag & SELECT_ONLY_FIRST) ||
+					(xc == xcOld && yc == ycOld))
+				{
+					c = gMouse.currentButtons == SDL_BUTTON_LEFT ?
+						SDLK_PAGEUP : SDLK_PAGEDOWN;
+				}
 			}
-			break;
 		}
+
+		HandleInput(c, &xc, &yc, &mission, &scrap, &done);
 		Display(mission, xc, yc, c);
 		SDL_Delay(10);
 	}
diff --git a/src/charsed.c b/src/charsed.c
index 82beaa1b5..d343967fb 100644
--- a/src/charsed.c
+++ b/src/charsed.c
@@ -579,123 +579,141 @@ void RestoreBkg(int x, int y, unsigned int *bkg)
 	}
 }
 
-void EditCharacters(CampaignSetting *setting)
+static void HandleInput(
+	int c, int *xc, int *yc,
+	int *idx, CampaignSetting *setting, TBadGuy *scrap, int *done)
 {
-	int done = 0;
-	int idx = 0;
-	int xc = 0, yc = 0;
-	TBadGuy scrap;
-
-	memset(&scrap, 0, sizeof(scrap));
-	MouseSetRects(&gMouse, localClicks, NULL);
-
-	while (!done)
+	if (gKeyboard.modState & (KMOD_ALT | KMOD_CTRL))
 	{
-		int tag;
-		int c;
-		KeyPoll(&gKeyboard);
-		c = KeyGetPressed(&gKeyboard);
-		MousePoll(&gMouse);
-		if (gMouse.currentButtons)
+		switch (c)
 		{
-			if (PosToCharacterIndex(gMouse.currentPos, &tag))
-			{
-				if (tag >= 0 && tag < setting->characterCount)
-				{
-					idx = tag;
-				}
-				c = DUMMY;
-			}
-			else if (MouseTryGetRectTag(&gMouse, &tag))
-			{
-				xc = (tag >> 8);
-				yc = (tag & 0xFF);
-				AdjustYC(&yc);
-				AdjustXC(yc, &xc);
-				c = gMouse.currentButtons == SDL_BUTTON_LEFT ?
-					PAGEUP : PAGEDOWN;
-			}
-		}
-
-		switch (c) {
-		case HOME:
-			if (idx > 0)
-			{
-				idx--;
-			}
+		case 'x':
+			*scrap = setting->characters[*idx];
+			DeleteCharacter(setting, idx);
+			fileChanged = 1;
 			break;
 
-		case END:
-			if (idx < setting->characterCount - 1)
-			{
-				idx++;
-			}
+		case 'c':
+			*scrap = setting->characters[*idx];
 			break;
 
-		case INSERT:
-			InsertCharacter(setting, idx, NULL);
+		case 'v':
+			InsertCharacter(setting, *idx, scrap);
 			fileChanged = 1;
 			break;
 
-		case ALT_X:
-			scrap = setting->characters[idx];
-
-		case DELETE:
-			DeleteCharacter(setting, &idx);
+		case 'n':
+			InsertCharacter(setting, setting->characterCount, NULL);
+			*idx = setting->characterCount - 1;
 			fileChanged = 1;
 			break;
+		}
+	}
+	else
+	{
+		switch (c)
+		{
+		case SDLK_HOME:
+			if (*idx > 0)
+			{
+				(*idx)--;
+			}
+			break;
 
-		case ALT_C:
-			scrap = setting->characters[idx];
+		case SDLK_END:
+			if (*idx < setting->characterCount - 1)
+			{
+				(*idx)++;
+			}
 			break;
 
-		case ALT_V:
-			InsertCharacter(setting, idx, &scrap);
+		case SDLK_INSERT:
+			InsertCharacter(setting, *idx, NULL);
 			fileChanged = 1;
 			break;
 
-		case ALT_N:
-			InsertCharacter(setting, setting->characterCount, NULL);
-			idx = setting->characterCount - 1;
+		case SDLK_DELETE:
+			DeleteCharacter(setting, idx);
 			fileChanged = 1;
 			break;
 
-		case ARROW_UP:
-			yc--;
-			AdjustYC(&yc);
-			AdjustXC(yc, &xc);
+		case SDLK_UP:
+			(*yc)--;
+			AdjustYC(yc);
+			AdjustXC(*yc, xc);
 			break;
 
-		case ARROW_DOWN:
-			yc++;
-			AdjustYC(&yc);
-			AdjustXC(yc, &xc);
+		case SDLK_DOWN:
+			(*yc)++;
+			AdjustYC(yc);
+			AdjustXC(*yc, xc);
 			break;
 
-		case ARROW_LEFT:
-			xc--;
-			AdjustXC(yc, &xc);
+		case SDLK_LEFT:
+			(*xc)--;
+			AdjustXC(*yc, xc);
 			break;
 
-		case ARROW_RIGHT:
-			xc++;
-			AdjustXC(yc, &xc);
+		case SDLK_RIGHT:
+			(*xc)++;
+			AdjustXC(*yc, xc);
 			break;
 
-		case PAGEUP:
-			Change(setting, idx, yc, xc, 1);
+		case SDLK_PAGEUP:
+			Change(setting, *idx, *yc, *xc, 1);
 			fileChanged = 1;
 			break;
 
-		case PAGEDOWN:
-			Change(setting, idx, yc, xc, -1);
+		case SDLK_PAGEDOWN:
+			Change(setting, *idx, *yc, *xc, -1);
 			fileChanged = 1;
 			break;
 
-		case ESCAPE:
-			done = 1;
+		case SDLK_ESCAPE:
+			*done = 1;
 			break;
 		}
+	}
+}
+
+void EditCharacters(CampaignSetting *setting)
+{
+	int done = 0;
+	int idx = 0;
+	int xc = 0, yc = 0;
+	TBadGuy scrap;
+
+	memset(&scrap, 0, sizeof(scrap));
+	MouseSetRects(&gMouse, localClicks, NULL);
+
+	while (!done)
+	{
+		int tag;
+		int c;
+		KeyPoll(&gKeyboard);
+		c = KeyGetPressed(&gKeyboard);
+		MousePoll(&gMouse);
+		if (gMouse.currentButtons)
+		{
+			if (PosToCharacterIndex(gMouse.currentPos, &tag))
+			{
+				if (tag >= 0 && tag < setting->characterCount)
+				{
+					idx = tag;
+				}
+			}
+			else if (MouseTryGetRectTag(&gMouse, &tag))
+			{
+				xc = (tag >> 8);
+				yc = (tag & 0xFF);
+				AdjustYC(&yc);
+				AdjustXC(yc, &xc);
+				c = gMouse.currentButtons == SDL_BUTTON_LEFT ?
+					SDLK_PAGEUP : SDLK_PAGEDOWN;
+			}
+		}
+
+		HandleInput(c, &xc, &yc, &idx, setting, &scrap, &done);
 		Display(setting, idx, xc, yc);
 		SDL_Delay(10);
 	}
diff --git a/src/charsed.h b/src/charsed.h
index 632620028..87e26f19d 100644
--- a/src/charsed.h
+++ b/src/charsed.h
@@ -27,42 +27,6 @@
 #define MAX_MISSIONS    50
 #define MAX_CHARACTERS  50
 
-#define PAGEUP      0x4900
-#define PAGEDOWN    0x5100
-#define HOME        0x4700
-#define END         0x4f00
-#define INSERT      0x5200
-#define DELETE      0x5300
-#define ALT_X       0x2d00
-#define ALT_C       0x2e00
-#define ALT_V       0x2f00
-#define ALT_Q       0x1000
-#define ALT_E       0x1200
-#define ARROW_UP    0x4800
-#define ARROW_DOWN  0x5000
-#define ARROW_LEFT  0x4b00
-#define ARROW_RIGHT 0x4d00
-#define BACKSPACE   8
-#define ESCAPE      27
-#define F1          0x3b00
-#define F2          0x3c00
-#define F3          0x3d00
-#define F4          0x3e00
-#define F10         0x4400
-#define F11         0x8500
-#define F12         0x8600
-#define sF1         0x5400
-#define sF2         0x5500
-#define sF3         0x5600
-#define sF4         0x5700
-#define ALT_N       0x3100
-#define ALT_S       0x1f00
-#define ALT_M       0x3200
-#define ALT_H       0x2300
-#define ENTER       13
-#define DUMMY       0x7FFF
-
-
 extern int fileChanged;
 
 
